﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using p = RUSMJ.clsConst;

namespace RUSMJ {
    public class clsFunction {


        /// <summary>
        /// プレイヤー構造体を初期化する
        /// </summary>
        public void initPlayer() {

            for(int i=0; i<3; i++) {
                p.typPlayer player = new p.typPlayer();
                player.AnPai = new int[14];
                player.MinPai = new int[12];

                player.Point = 25000;
                player.Kaze = p.eKaze.Ton;
                player.MenzenFlg = false;
                player.OwnerFlg = false;

                p.pPlayer[i] = player;
            }

        }


        /// <summary>
        /// 局の開始処理
        /// </summary>
        public void startGame() {

            // プレイヤー情報の初期化
            for (int i = 0; i < 4; i++) {
                p.pPlayer[i].AnPai = new int[14];
                p.pPlayer[i].MinPai = new int[12];
                p.pPlayer[i].MenzenFlg = false;
                p.pPlayer[i].OwnerFlg = false;
            }

            // 仮：とりあえず最初の人が親で・・・
            if (p.pFastGameFlg == true) {
                p.pPlayer[0].OwnerFlg = true;
                p.pPlayOwner = p.eKaze.Ton;
            }
            
            p.pTakuPai = new int[122];
            p.pRinsyanPai = new int[14];

            initSetPai();

            setPlayerPai(p.pPlayOwner);

        }

        /// <summary>
        /// 各牌をセットする
        /// </summary>
        private void initSetPai() {

            int[] paiArray = new int[136];
            int paiCnt = 0;

            // 各牌をセットする
            for(int i = 0; i < 4; i++) {

                for(int j = 0; j < p.P_WANZU.Length; j++) {
                    paiArray[paiCnt] = p.P_WANZU[j];
                    paiCnt++;
                }

                for(int j = 0; j < p.P_SOUZU.Length; j++) {
                    paiArray[paiCnt] = p.P_SOUZU[j];
                    paiCnt++;
                }

                for(int j = 0; j < p.P_PINZU.Length; j++) {
                    paiArray[paiCnt] = p.P_PINZU[j];
                    paiCnt++;
                }

                for(int j = 0; j < p.P_KAZE.Length; j++) {
                    paiArray[paiCnt] = p.P_KAZE[j];
                    paiCnt++;
                }

                for(int j = 0; j < p.P_SNGN.Length; j++) {
                    paiArray[paiCnt] = p.P_SNGN[j];
                    paiCnt++;
                }

            }

            // 牌のシャッフル
            paiShuffle(paiArray);

            // 卓牌をセット
            for (int i = 0; i < 122; i++) {
                p.pTakuPai[i] = paiArray[i];
            }

            // 嶺上牌をセット
            for (int i = 122; i < paiArray.Length; i++) {
                p.pRinsyanPai[i - 122] = paiArray[i];
            }

        }


        private void setPlayerPai(p.eKaze oya) {

            // 13牌×4人 = 52
            for (int i = 0; i < 52; i++) {


                if (i >= 0 && i <= 12) {
                    p.pPlayer[0].AnPai[i] = p.pTakuPai[i];
                }

                if (i >= 13 && i <= 26) {
                    p.pPlayer[1].AnPai[i-13] = p.pTakuPai[i];
                }

                if (i >= 27 && i <= 39) {
                    p.pPlayer[2].AnPai[i - 27] = p.pTakuPai[i];
                }

                if (i >= 39 && i <= 52) {
                    p.pPlayer[3].AnPai[i - 39] = p.pTakuPai[i];
                }

            }

        }



        /// <summary>
        /// Fisher-Yatesアルゴリズムでシャッフルする
        /// </summary>
        /// <param name="ary">配列</param>
        private void paiShuffle(int[] ary) {

            System.Random rng = new System.Random(Environment.TickCount);
            int n = ary.Length;

            while (n > 1) {
                n--;
                int k = rng.Next(n + 1);
                int tmp = ary[k];
                ary[k] = ary[n];
                ary[n] = tmp;
            }

        }


    }
}
