//
//	CEChE
//
//		Copyright (c) 2000-2002 Chihiro.SAKAMOTO (HyperWorks)
//
#include "StdAfx.h"
#include "GraphicTest.h"
#include "Window.h"
#include "MainWin.h"
#include "AboutDlg.h"
#include "Misc.h"
#include "dc.h"
#include "resource.h"

// CG̕\ʒu
const CRect CMainWin::Position[] = {
	CRect(0, 0, 0, 0),												// None
	CRect(0, 0, WindowWidth / 2, WindowHeight),						// Left
	CRect(WindowWidth / 2, 0, WindowWidth, WindowHeight),			// Right
	CRect(0, 0, WindowWidth, WindowHeight),							// Both
	CRect(WindowWidth / 4, 0, WindowWidth * 3 / 4, WindowHeight),	// Center
} ;

//
// RXgN^
//
//	ϐ̏sȂ
//	EChȄ́AOnCreateōsȂ̂ŁAł͉Ȃ
//
CMainWin::CMainWin()
	:InvalidRect(0, 0, 0, 0)
{
	OverlapFlags = 0;
	BgColor = BlackPixel;

	OverlapBounds.SetRectEmpty();
	BackShow = FALSE;
	OverlapShow = FALSE;
}

//
// fXgN^
//
CMainWin::~CMainWin()
{
}

//
// EChE쐬O
//
//	X^CƃTCYw肷
//
BOOL CMainWin::PreCreateWindow(CREATESTRUCT &cs)
{
	cs.dwExStyle = WS_EX_CLIENTEDGE;
	cs.style = WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX;

	CRect	rect(0, 0, WindowWidth, WindowHeight);
	::AdjustWindowRectEx(&rect, cs.style, TRUE, cs.dwExStyle);

	int width = rect.Width();
	int height = rect.Height();

	CRect rcArea;
	SystemParametersInfo(SPI_GETWORKAREA, NULL, &rcArea, NULL);

	int	x = rcArea.left + (rcArea.Width() - width) / 2;
	int	y = rcArea.top + (rcArea.Height() - height) / 2;

	cs.x = x;
	cs.y = y;
	cs.cx = width;
	cs.cy = height;
	cs.lpszClass = "MainWindow";

	// CS_OWNDC w肵āAGetDC
	if (!Application->RegisterWndClass(cs.lpszClass,
		CS_VREDRAW | CS_HREDRAW | CS_OWNDC, LoadCursor(NULL, IDC_ARROW),
		(HBRUSH)::GetStockObject(BLACK_BRUSH), Application->LoadIcon(IDC_APPICON)))
		return FALSE;
	return TRUE;
}

//
// bZ[W
//
LRESULT CMainWin::WindowProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	  case WM_CLOSE:			// EChE
		OnClose();
		break;

	  case WM_ERASEBKGND:		// wi
		return FALSE;			// Ȃ

	  default:
		return CWindow::WindowProc(uMsg, wParam, lParam);
	}
	return 0L;
}

//
// WM_CREATȄ
//
BOOL CMainWin::OnCreate(CREATESTRUCT *cs)
{
	LoadAccelTable(IDC_APPACCEL);

	CClientDC	dc(this);

	// C[Ẅm
	if (!MixedImage.Create(dc, WindowWidth, WindowHeight)
	 || !BackLayer.Create(WindowWidth, WindowHeight)
	 || !OverlapLayer.Create(WindowWidth, WindowHeight)) {
		MessageBox("[Amۂł܂B\n"
			"ɊJĂAvP[VIĂAċNĉB");
		return FALSE;
	}

	MixedImage.Clear();

	return TRUE;
}

//
// WM_CLOSȄ
//
void CMainWin::OnClose()
{
	if (MessageBox("I܂A낵łH", ApplicationTitle,
		MB_ICONQUESTION|MB_OKCANCEL) == IDOK) {
		::DestroyWindow(hWnd);
	}
}

//
// WM_PAINT̏iĕ`j
//
void CMainWin::OnPaint()
{
	CPaintDC	dc(this);
	MixedImage.Draw(dc, dc.ps.rcPaint);
}

//
// WM_COMMAND̏ij[̏j
//
void CMainWin::OnCommand(UINT notifyCode, UINT id, HWND ctrl)
{
	switch (id) {
	  case ID_APP_EXIT:				// I
		SendMessage(WM_CLOSE);
		break;

	  case ID_APP_ABOUT:			// ްޮݏ
		CAboutDlg().DoModal(IDD_ABOUT, hWnd);
		break;

	  case IDC_BACKLOAD:			// ǂݍ݁|wi
		LoadImageBack("back");
		Update();
		break;

	  case IDC_BACKCLEAR:			// |wi
		ClearBack();
		Update();
		break;

	  case IDC_RIGHTLOAD:			// ǂݍ݁|E
		LoadImageRight("right");
		Update();
		break;

	  case IDC_RIGHTCLEAR:			// |E
		ClearRight();
		Update();
		break;

	  case IDC_LEFTLOAD:			// ǂݍ݁|
		LoadImageLeft("left");
		Update();
		break;

	  case IDC_LEFTCLEAR:			// |
		ClearLeft();
		Update();
		break;

	  case IDC_CENTERLOAD:			// ǂݍ݁|
		LoadImageCenter("center");
		Update();
		break;

	  case IDC_CENTERCLEAR:			// |
		ClearCenter();
		Update();
		break;

	  default:
		break;
	}
}

//
// I[o[bv̏dˏ󋵂ύX
//
void CMainWin::ShowOverlapLayer(int pos)
{
	if (OverlapShow) {		// \ԂH
		// ̕\ɗޏꍇAȑO̕\
		if ((OverlapFlags == Center && pos != Center)		// ->̑
		 || (OverlapFlags != Center && pos == Center)) {	// ̑->
			Invalidate(Position[OverlapFlags]);
			OverlapFlags = None;
			OverlapBounds.SetRectEmpty();
		}
	}
	OverlapFlags |= pos;

	OverlapBounds = Position[OverlapFlags];
	OverlapShow = TRUE;

	Invalidate(Position[pos]);
}

//
// I[o[bv
//
//	ۂɂ́A\󋵂ύX邾
//
void CMainWin::HideOverlapLayer(int pos)
{
	if (OverlapShow) {		// \ԂH
		// ̕\ɗޏꍇAȑO̕\
		if ((OverlapFlags == Center && pos != Center)		// ->̑
		 || (OverlapFlags != Center && pos == Center)) {	// ̑->
			Invalidate(Position[OverlapFlags]);
			OverlapFlags = None;
			OverlapBounds.SetRectEmpty();
		}
	}
	OverlapFlags &= ~pos;

	OverlapBounds = Position[OverlapFlags];
	if (OverlapFlags == None)
		OverlapShow = FALSE;

	Invalidate(Position[pos]);
}

//
// \egݗĂ
//
void CMainWin::Mixing(const CRect &rect)
{
	// wi
	if (BackShow)
		MixedImage.Copy(&BackLayer, rect);		// wi΃Rs[
	else
		MixedImage.FillRect(rect, BgColor);		// wiȂΓhԂ

	// d
	if (OverlapShow)							// d˂΍
		MixedImage.MixImage(&OverlapLayer, OverlapBounds & rect);
}

//
// ʂɕωꍇĕ`悷
//
BOOL CMainWin::Update(bool repaint)
{
	if (!InvalidRect.IsRectEmpty()) {			// ̈悪
		Mixing(InvalidRect);					// 
		if (repaint)
			Repaint(InvalidRect);				// ĕ`
		InvalidRect.SetRectEmpty();				// ̈uvɂ
		return TRUE;							// Update
	}
	return FALSE;								// Ȃ
}

//
// wiCGǂݍ
//
BOOL CMainWin::LoadImageBack(const char *name)
{
	BackShow = TRUE;
	Invalidate(Position[Both]);
	return BackLayer.LoadImage(name);
}

//
// dCGǂݍ
//
BOOL CMainWin::LoadImageOverlap(const char *name, int pos)
{
	ShowOverlapLayer(pos);
	return OverlapLayer.LoadImage(name, Position[pos].left, Position[pos].top);
}

//
// wiCG
//
BOOL CMainWin::ClearImageBack()
{
	BackShow = FALSE;
	Invalidate(Position[Both]);
	return TRUE;
}
