//
//	CEChE
//
//		Copyright (c) 2000-2002 Chihiro.SAKAMOTO (HyperWorks)
//
#ifndef __MainWin_h__
#define __MainWin_h__

#include "Window.h"
#include "dc.h"
#include "Image.h"
#include "DrawImage.h"

//
//	CEChENX
//
class CMainWin: public CWindow {
  protected:
	// 萔

	// I[o[bv̕\ʒu
	enum	{
		None = 0,
		Left = 1,
		Right = 2,
		Both = 3,
		Center = 4,
	} ;

  public:
	CMainWin();
	~CMainWin();

	LRESULT WindowProc(UINT uMsg, WPARAM wParam, LPARAM lParam);

	void OnCommand(UINT notifyCode, UINT id, HWND ctrl);

	BOOL LoadImageBack(const char *name);

	BOOL LoadImageLeft(const char *name) { return LoadImageOverlap(name, Left); }
	BOOL LoadImageRight(const char *name) { return LoadImageOverlap(name, Right); }
	BOOL LoadImageCenter(const char *name) { return LoadImageOverlap(name, Center); }
	BOOL LoadImageOverlap(const char *name) { return LoadImageOverlap(name, Both); }

	void ClearBack() { ClearImageBack(); }
	void ClearCenter() { HideOverlapLayer(Center); }
	void ClearLeft() { HideOverlapLayer(Left); }
	void ClearRight() { HideOverlapLayer(Right); }
	void ClearOverlap() { HideOverlapLayer(Both); }

	const CRect &GetInvalidRect() const { return InvalidRect; }

	void Repaint(const CRect &rect);
	void UpdateImage(const CRect &rect);

  protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT &cs);

	BOOL OnCreate(CREATESTRUCT *cs);
	void OnClose();
	void OnPaint();

	BOOL LoadImageOverlap(const char *name, int position);
	BOOL ClearImageBack();
	void ShowOverlapLayer(int pos);
	void HideOverlapLayer(int pos);
	BOOL Update(bool repaint=true);

	void Mixing(const CRect &rect);

	void Invalidate(const CRect &rect) { InvalidRect |= rect; }

  protected:
	CDrawImage	MixedImage;				// 
	CImage		BackLayer;				// wi
	CImage		OverlapLayer;			// d
	unsigned	OverlapFlags;			// dˏԃtO

	CRect		InvalidRect;			// ̈
	CRect		OverlapBounds;			// udˁv̗L̈
	BOOL		BackShow;				// wi\H
	BOOL		OverlapShow;			// d˂\H
	COLORREF	BgColor;				// wiȂɓhԂF

	static const CRect Position[];
} ;

// CCo֐

//
//	[̃C[W\
//
inline void CMainWin::Repaint(const CRect &rect)
{
	MixedImage.Draw(CClientDC(this), rect);
}

//
//	ĕ`悷OɁÄ悪΃[̃C[W
//
inline void CMainWin::UpdateImage(const CRect &rect)
{
	Update();
	Repaint(rect);
}

#endif
