//
//	XNvgv[[CEChE
//
//		Copyright (c) 2000-2002 Chihiro.SAKAMOTO (HyperWorks)
//
#include "StdAfx.h"
#include "ScrPlay.h"
#include "Window.h"
#include "MainWin.h"
#include "AboutDlg.h"
#include "Misc.h"
#include "dc.h"
#include "resource.h"

// CG̕\ʒu
const CRect CMainWin::Position[] = {
	CRect(0, 0, 0, 0),												// None
	CRect(0, 0, WindowWidth / 2, WindowHeight),						// Left
	CRect(WindowWidth / 2, 0, WindowWidth, WindowHeight),			// Right
	CRect(0, 0, WindowWidth, WindowHeight),							// Both
	CRect(WindowWidth / 4, 0, WindowWidth * 3 / 4, WindowHeight),	// Center
} ;

//
// RXgN^
//
//	ϐ̏sȂ
//	EChȄ́AOnCreateōsȂ̂ŁAł͉Ȃ
//
CMainWin::CMainWin():
	TextRect(MSG_X, MSG_Y, MSG_X + MSG_W, MSG_Y + MSG_H),
	WaitMarkRect(MsgX(WAITMARK_X), MsgY(WAITMARK_Y),
		MsgX(WAITMARK_X) + MessageFont, MsgY(WAITMARK_Y) + MessageFont),
	InvalidRect(0, 0, 0, 0)
{
	CurX = CurY = 0;
	OverlapFlags = 0;
	BgColor = BlackPixel;
	TextDisplay = FALSE;
	WaitMarkShowing = FALSE;

	OverlapBounds.SetRectEmpty();
	BackShow = FALSE;
	OverlapShow = FALSE;
	TextShow = FALSE;
	MenuShow = FALSE;

	Action = &NopAction;
	hFont = 0;
}

//
// fXgN^
//
CMainWin::~CMainWin()
{
	if (hFont) {
		DeleteObject(hFont);
		hFont = 0;
	}
}

//
// EChE쐬O
//
//	X^CƃTCYw肷
//
BOOL CMainWin::PreCreateWindow(CREATESTRUCT &cs)
{
	cs.dwExStyle = WS_EX_CLIENTEDGE;
	cs.style = WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX;

	CRect	rect(0, 0, WindowWidth, WindowHeight);
	::AdjustWindowRectEx(&rect, cs.style, TRUE, cs.dwExStyle);

	int width = rect.Width();
	int height = rect.Height();

	CRect rcArea;
	SystemParametersInfo(SPI_GETWORKAREA, NULL, &rcArea, NULL);

	int	x = rcArea.left + (rcArea.Width() - width) / 2;
	int	y = rcArea.top + (rcArea.Height() - height) / 2;

	cs.x = x;
	cs.y = y;
	cs.cx = width;
	cs.cy = height;
	cs.lpszClass = "MainWindow";

	// CS_OWNDC w肵āAGetDC
	if (!Application->RegisterWndClass(cs.lpszClass,
		CS_VREDRAW | CS_HREDRAW | CS_OWNDC, LoadCursor(NULL, IDC_ARROW),
		(HBRUSH)::GetStockObject(BLACK_BRUSH), Application->LoadIcon(IDC_APPICON)))
		return FALSE;
	return TRUE;
}

//
// bZ[W
//
LRESULT CMainWin::WindowProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	  case WM_FIRSTACTION:		// ŏɑ郁bZ[W
		OnFirstAction();
		break;

	  case WM_CLOSE:			// EChE
		OnClose();
		break;

	  case WM_ERASEBKGND:		// wi
		return FALSE;			// Ȃ

	  case WM_LBUTTONDOWN:		// }EX{^ꂽ
		Action->LButtonDown(wParam, CPoint(lParam));
		break;

	  case WM_LBUTTONUP:		// }EX{^ꂽ
		Action->LButtonUp(wParam, CPoint(lParam));
		break;

	  case WM_RBUTTONDOWN:		// }EXE{^ꂽ
		Action->RButtonDown(wParam, CPoint(lParam));
		break;

	  case WM_RBUTTONUP:		// }EXE{^ꂽ
		Action->RButtonUp(wParam, CPoint(lParam));
		break;

	  case WM_MOUSEMOVE:		// }EX|C^ړ
		Action->MouseMove(wParam, CPoint(lParam));
		break;

	  case WM_KEYDOWN:			// L[{[hꂽ
		Action->KeyDown(wParam);
		break;

	  default:
		return CWindow::WindowProc(uMsg, wParam, lParam);
	}
	return 0L;
}

//
// IDLE
//
BOOL CMainWin::OnIdle(long count)
{
	return Action->IdleAction();
}

//
// WM_CREATȄ
//
BOOL CMainWin::OnCreate(CREATESTRUCT *cs)
{
	LoadAccelTable(IDC_APPACCEL);

	CClientDC	dc(this);

	// C[Ẅm
	if (!MixedImage.Create(dc, WindowWidth, WindowHeight)
	 || !BackLayer.Create(WindowWidth, WindowHeight)
	 || !OverlapLayer.Create(WindowWidth, WindowHeight)) {
		MessageBox("[Amۂł܂B\n"
			"ɊJĂAvP[VIĂAċNĉB");
		return FALSE;
	}

	// \pC[WijNA
	MixedImage.Clear();

	// tHg炩ߐĂ
	if ((hFont = CreateFont(-MessageFont, 0, 0, 0, MessageStyle, FALSE, FALSE, FALSE,
		SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_CHARACTER_PRECIS,
		DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, "lr SVbN")) == 0) {
		MessageBox("SVbNtHg܂B");
		return FALSE;
	}

	SetAction(ActionNop);

	// ɂȂŏ̃bZ[W𑗏o
	while (!PostMessage(WM_FIRSTACTION)) {
		// PostMessage̓L[tƃG[ɂȂ̂ŌJԂ
#ifdef	_DEBUG
		TRACE("PostMessage Error code = %d\n", GetLastError());
#endif
		::Sleep(110);	// bZ[W̍đ́A҂
	}
	return TRUE;
}

//
// Q[̢ŏ̓
//
void CMainWin::OnFirstAction()
{
	// ŏɍŝ́uCj[v
	StartMainMenu();
}

//
// WM_CLOSȄ
//
void CMainWin::OnClose()
{
	if (MessageBox("I܂A낵łH", ApplicationTitle,
		MB_ICONQUESTION|MB_OKCANCEL) == IDOK) {
		::DestroyWindow(hWnd);
	}
}

//
// WM_PAINT̏iĕ`j
//
void CMainWin::OnPaint()
{
	CPaintDC	dc(this);
	MixedImage.Draw(dc, dc.ps.rcPaint);
}

//
// WM_COMMAND̏ij[̏j
//
void CMainWin::OnCommand(UINT notifyCode, UINT id, HWND ctrl)
{
	switch (id) {
	  case ID_APP_EXIT:				// I
		SendMessage(WM_CLOSE);
		break;

	  case ID_APP_ABOUT:			// ްޮݏ
		CAboutDlg().DoModal(IDD_ABOUT, hWnd);
		break;

	  case ID_STOPSCRIPT:			// ViIf
		if (IsStopScript() && MessageBox("f܂A낵łH", ApplicationTitle,
			MB_ICONQUESTION|MB_OKCANCEL) == IDOK)
			ScriptAction.Abort();
		break;

	  default:
		break;
	}
}

//
// j[ڂ̏
//
void CMainWin::OnInitSubMenu(HMENU hMenu, UINT id)
{
	switch (id) {
	  case ID_STOPSCRIPT:			// ViIf
		// ViI̎ŝ݃j[Cl[uɂ
		EnableMenuItem(hMenu, id, IsStopScript()? MF_ENABLED: (MF_DISABLED | MF_GRAYED));
		break;
	}
}

//
// ANV̐؂ւ
//
BOOL CMainWin::SetAction(int action, int param)
{
	switch (action) {
	  case ActionNop:			// Ȃ
		Action = &NopAction;
		NopAction.Initialize(this);
		break;

	  case ActionScriptDone:	// XNvgI
		StartMainMenu();
		break;

	  case ActionScript:		// XNvg̎s
		Action = &ScriptAction;
		break;
	}
	PostMessage(WM_KICKIDLE);	// Ô߁A󃁃bZ[W𑗂

	return TRUE;
}

//
// XNvg̎s
//
bool CMainWin::StartScript(const char *name, int mode)
{
	ScriptAction.Initialize(this, mode);	// 
	if (!ScriptAction.Load(name))			// ViIǂ
		return false;
	SetAction(ActionScript);				// sJn
	return true;
}

//
// Cj[
//
//	Cj[XNvgs
//
void CMainWin::StartMainMenu()
{
	if (!StartScript("main", MODE_SYSTEM))
		::DestroyWindow(hWnd);
}

//
// bZ[WGAɃeLXg
//
void CMainWin::WriteMessage(const char *msg)
{
	FormatMessage(msg);

	WaitMarkShowing = TRUE;

	ShowMessageWindow();
}

//
// uL[҂v}[N
//
void CMainWin::HideWaitMark()
{
	if (WaitMarkShowing) {
		WaitMarkShowing = FALSE;
		if (TextShow) {
			Mixing(WaitMarkRect, TextWaitMark);
			Repaint(WaitMarkRect);
		}
	}
}

//
// j[̕`
//
void CMainWin::OpenMenu()
{
	int		maxlen = MENU_MIN_WIDTH;

	{
		CMemoryDC	memdc(0);
		HFONT	oldFont = memdc.SelectObject(hFont);

		for (int i=0; i<MenuCount; i++) {
			CSize	size;
			memdc.GetTextExtentPoint32(MenuBuffer[i].text, MenuBuffer[i].length, &size);
			if (maxlen < size.cx)
				maxlen = size.cx;
		}
		memdc.SelectObject(oldFont);
	}

	MenuRect.top = MENU_Y - ((MENU_FRAME_HEIGHT * 2)
		+ MenuCount * MENU_ITEM_HEIGHT - MENU_ITEM_SPACE);
	MenuRect.left = MENU_X;
	MenuRect.bottom = MENU_Y;
	MenuRect.right = MENU_X + (MENU_FRAME_WIDTH * 2) + maxlen;

	MenuShow = TRUE;
	Mixing(MenuRect);
	Repaint(MenuRect);
}

//
// j[̍ڂI/I\
//
void CMainWin::SelectMenu(int index, bool select)
{
	if (index >= 0) {
		MenuBuffer[index].color = select? RedPixel: WhitePixel;
		CRect	rect;
		rect.left = MenuRect.left + MENU_FRAME_WIDTH;
		rect.top = MenuRect.top + MENU_FRAME_HEIGHT + MENU_ITEM_HEIGHT * index;
		rect.right = rect.left + MenuRect.Width() - MENU_FRAME_WIDTH * 2;
		rect.bottom = rect.top + MessageFont;
		Mixing(rect, MenuItem(index));
		Repaint(rect);
	}
}

//
// bZ[WGA\
//
void CMainWin::ShowMessageWindow()
{
	TextDisplay = TRUE;

	TextShow = TRUE;
	Invalidate(TextRect);
	Update();
}

//
// bZ[WGA
//
void CMainWin::HideMessageWindow(bool update)
{
	TextDisplay = FALSE;

	if (TextShow) {
		TextShow = FALSE;
		Invalidate(TextRect);
		if (update)
			Update();
	}
}

//
// bZ[WGAI/I\
//
void CMainWin::FlipMessageWindow()
{
	if (TextDisplay) {
		TextShow = TextShow? FALSE: TRUE;
		Invalidate(TextRect);
		Update();
	}
}

//
// I[o[bv̏dˏ󋵂ύX
//
void CMainWin::ShowOverlapLayer(int pos)
{
	if (OverlapShow) {		// \ԂH
		// ̕\ɗޏꍇAȑO̕\
		if ((OverlapFlags == Center && pos != Center)		// ->̑
		 || (OverlapFlags != Center && pos == Center)) {	// ̑->
			Invalidate(Position[OverlapFlags]);
			OverlapFlags = None;
			OverlapBounds.SetRectEmpty();
		}
	}
	OverlapFlags |= pos;

	OverlapBounds = Position[OverlapFlags];
	OverlapShow = TRUE;

	Invalidate(Position[pos]);
}

//
// I[o[bv
//
//	ۂɂ́A\󋵂ύX邾
//
void CMainWin::HideOverlapLayer(int pos)
{
	if (OverlapShow) {		// \ԂH
		// ̕\ɗޏꍇAȑO̕\
		if ((OverlapFlags == Center && pos != Center)		// ->̑
		 || (OverlapFlags != Center && pos == Center)) {	// ̑->
			Invalidate(Position[OverlapFlags]);
			OverlapFlags = None;
			OverlapBounds.SetRectEmpty();
		}
	}
	OverlapFlags &= ~pos;

	OverlapBounds = Position[OverlapFlags];
	if (OverlapFlags == None)
		OverlapShow = FALSE;

	Invalidate(Position[pos]);
}

//
// j[
//
void CMainWin::HideMenuWindow(bool update)
{
	if (MenuShow) {
		MenuShow = FALSE;
		Invalidate(MenuRect);
		if (update)
			Update();
	}
}

//
// ʂׂ̂Ă\ɂ
//
//	pix ́AʂhԂF
//
void CMainWin::HideAllLayer(COLORREF pix)
{
	BgColor = pix;
	BackShow = FALSE;
	OverlapShow = FALSE;
	OverlapFlags = None;
	OverlapBounds.SetRectEmpty();
}

//
// \egݗĂ
//
void CMainWin::Mixing(const CRect &rect, unsigned flags)
{
	// wi
	if (BackShow)
		MixedImage.Copy(&BackLayer, rect);		// wi΃Rs[
	else
		MixedImage.FillRect(rect, BgColor);		// wiȂΓhԂ

	// d
	if (OverlapShow)							// d˂΍
		MixedImage.MixImage(&OverlapLayer, OverlapBounds & rect);

	// bZ[Ẅ
	if (TextShow) {
		if (flags & TextMessage) {
			MixedImage.DrawFrameRect(TextRect);
			for (int i=0; i<MessageLine; i++) {
				MixedImage.DrawText(hFont, MsgX(0), MsgY(i), MsgBuffer[i]);
			}
		}
		else {
			MixedImage.FillHalfToneRect(TextRect & rect);
		}
		if (WaitMarkShowing && flags & TextWaitMark)
			MixedImage.DrawText(hFont, MsgX(WAITMARK_X), MsgY(WAITMARK_Y), "");
	}
	// j[
	if (MenuShow) {
		if (flags & MenuFrame)
			MixedImage.DrawFrameRect(MenuRect);
		else
			MixedImage.FillHalfToneRect(MenuRect & rect);

		for (int i=0; i<MenuCount; i++) {
			if (flags & MenuItem(i)) {
				MixedImage.DrawText(hFont,
					MenuRect.left + MENU_FRAME_WIDTH,
					MenuRect.top + MENU_FRAME_HEIGHT + MENU_ITEM_HEIGHT * i,
					MenuBuffer[i].text, MenuBuffer[i].color);
			}
		}
	}
}

//
// ʂɕωꍇĕ`悷
//
BOOL CMainWin::Update(bool repaint)
{
	if (!InvalidRect.IsRectEmpty()) {			// ̈悪
		Mixing(InvalidRect);					// 
		if (repaint)
			Repaint(InvalidRect);				// ĕ`
		InvalidRect.SetRectEmpty();				// ̈uvɂ
		return TRUE;							// Update
	}
	return FALSE;								// Ȃ
}

//
// wiCGǂݍ
//
BOOL CMainWin::LoadImageBack(const char *name)
{
	BackShow = TRUE;
	Invalidate(Position[Both]);
	return BackLayer.LoadImage(name);
}

//
// dCGǂݍ
//
BOOL CMainWin::LoadImageOverlap(const char *name, int pos)
{
	ShowOverlapLayer(pos);
	return OverlapLayer.LoadImage(name, Position[pos].left, Position[pos].top);
}

//
// wiCG
//
BOOL CMainWin::ClearImageBack()
{
	BackShow = FALSE;
	Invalidate(Position[Both]);
	return TRUE;
}

//
// ֑肷
//
//	ŏĂ̂́Aŝ֑
//	֑̑Ώە́ARgQ
//
BOOL CMainWin::Kinsoku(const char *p)
{
	switch (UC(p[0])) {
	  case 0x81:
		switch (UC(p[1])) {
		  case 0x41:		// A
		  case 0x42:		// B
		  case 0x49:		// I
		  case 0x48:		// H
		  case 0x5B:		// [
		  case 0x6A:		// j
		  case 0x76:		// v
		  case 0x78:		// x
		  case 0x99:		// 
		  case 0xf4:		// 
			return TRUE;
		}
		break;

	  case 0x82:
		switch (UC(p[1])) {
		  case 0x9f:		// 
		  case 0xa1:		// 
		  case 0xa3:		// 
		  case 0xa5:		// 
		  case 0xa7:		// 
		  case 0xe1:		// 
		  case 0xe3:		// 
		  case 0xe5:		// 
		  case 0xc1:		// 
			return TRUE;
		}
		break;

	  case 0x83:
		switch (UC(p[1])) {
		  case 0x40:		// @
		  case 0x42:		// B
		  case 0x44:		// D
		  case 0x46:		// F
		  case 0x48:		// H
		  case 0x83:		// 
		  case 0x85:		// 
		  case 0x87:		// 
		  case 0x62:		// b
			return TRUE;
		}
	}
	return FALSE;
}

#define	STR_LIMIT	(MessageWidth - 2)
#define	STR_WIDTH	(STR_LIMIT - 2)

//
// eLXgobt@NA
//
void CMainWin::ClearMessage()
{
	HideMessageWindow();

	CurX = CurY = 0;

	for (int i=0; i<MessageLine; i++)
		MsgBuffer[i][0] = 0;
}

//
// eLXgobt@ɕtH[}bgăRs[
//
int CMainWin::FormatMessage(const char *msg)
{
	CurX = CurY = 0;

	for (int i=0; i<MessageLine; i++)
		MsgBuffer[i][0] = 0;

	while (*msg && CurY < MessageLine) {
		if (*msg == '\n') {
			msg++;
			MsgBuffer[CurY][CurX] = 0;
			CurX = 0;
			CurY++;
		}
		else if (_ismbblead(*msg)) {
			if (CurX >= STR_LIMIT || (CurX >= STR_WIDTH && Kinsoku(msg) == 0)) {
				MsgBuffer[CurY][CurX] = 0;
				CurX = 0;
				CurY++;
			}
			MsgBuffer[CurY][CurX++] = *msg++;
			MsgBuffer[CurY][CurX++] = *msg++;
		}
		else {
			if (CurX >= STR_WIDTH) {
				MsgBuffer[CurY][CurX] = 0;
				CurX = 0;
				CurY++;
			}
			MsgBuffer[CurY][CurX++] = *msg++;
		}
	}
	if (CurX > 0 && CurY < MessageLine) {
		MsgBuffer[CurY][CurX] = 0;
		CurY++;
	}
	return CurY;
}

//
// j[ڂZbg
//
void CMainWin::SetMenuItem(const char *str, int anser)
{
	int		n = strlen(str);
	memcpy(MenuBuffer[MenuCount].text, str, n + 1);
	MenuBuffer[MenuCount].anser = anser;
	MenuBuffer[MenuCount].length = n;
	MenuBuffer[MenuCount].color = WhitePixel;
	MenuCount++;
}
