//
//	XNvgv[[CEChE
//
//		Copyright (c) 2000-2002 Chihiro.SAKAMOTO (HyperWorks)
//
#ifndef __MainWin_h__
#define __MainWin_h__

#include "Window.h"
#include "dc.h"
#include "Action.h"
#include "Script.h"
#include "Image.h"
#include "DrawImage.h"

//
//	CEChENX
//
class CMainWin: public CWindow {
  public:
	// 萔

	// ANV
	enum	{
		ActionNop,
		ActionScriptDone,
		ActionScript,
	} ;

	// ڍő吔
	enum	{
		MAX_MENU_ITEM = 8,
		MAX_MENU_TEXT = 60,
	} ;

  protected:
	// I[o[bv̕\ʒu
	enum	{
		None = 0,
		Left = 1,
		Right = 2,
		Both = 3,
		Center = 4,
	} ;

	// bZ[W\ʒu
	enum	{
		MSG_W = MessageFont * MessageWidth / 2 + 20,
		MSG_H = (MessageFont + 2) * MessageLine + 14,
		MSG_X = (WindowWidth - MSG_W) / 2,
		MSG_Y = WindowHeight - MSG_H - 8,
		MSG_TEXTOFFSET_X = MSG_X + 10,
		MSG_TEXTOFFSET_Y = MSG_Y + 7,
		MSG_TEXTSPACE_Y = 2,
		WAITMARK_X = MessageWidth - 2,
		WAITMARK_Y = MessageLine - 1,
	} ;

	// j[\ʒu
	enum	{
		MENU_X = 20,
		MENU_Y = MSG_Y - 2,		// bZ[ẄɏdȂȂ悤
		MENU_WIDTH = (MAX_MENU_TEXT + 2) * MessageFont / 2,
		MENU_HEIGHT = (MAX_MENU_ITEM + 1) * MessageFont,
		MENU_MIN_WIDTH = 50,
		MENU_FRAME_WIDTH = 10,
		MENU_FRAME_HEIGHT = 10,
		MENU_ITEM_SPACE = 2,
		MENU_ITEM_HEIGHT = MessageFont + MENU_ITEM_SPACE,
	} ;

	// j[
	struct CMenuItem {
		char		text[MAX_MENU_TEXT];
		int			anser;
		int			length;
		COLORREF	color;
	} ;

	// ʍ
	enum	{
		TextMessage = 1 << 0,
		TextWaitMark = 1 << 1,
		MenuFrame = 1 << 2,
		MenuItemFirst = 3,
	} ;
	static unsigned MenuItem(int n) { return 1 << (MenuItemFirst + n); }

  public:
	CMainWin();
	~CMainWin();

	LRESULT WindowProc(UINT uMsg, WPARAM wParam, LPARAM lParam);

	virtual void OnInitSubMenu(HMENU hMenu, UINT id);
	virtual BOOL OnIdle(long count);

	void OnCommand(UINT notifyCode, UINT id, HWND ctrl);

	BOOL SetAction(int action, int param=0);
	bool StartScript(const char *name, int mode=0);
	void StartMainMenu();

	void WriteMessage(const char *msg);
	void ClearMessage();
	void HideWaitMark();
	void ShowMessageWindow();
	void HideMessageWindow(bool update=true);
	void FlipMessageWindow();

	void SetMenuItem(const char *lavel, int anser);
	void OpenMenu();
	void HideMenuWindow(bool update=true);
	void ClearMenuItemCount() { MenuCount = 0; }
	int GetMenuItemCount() const { return MenuCount; }
	int GetMenuAnser(int index) const { return MenuBuffer[index].anser; }
	int GetMenuSelect(CPoint point);
	void SelectMenu(int index, bool select);

	BOOL LoadImageBack(const char *name);

	BOOL LoadImageLeft(const char *name) { return LoadImageOverlap(name, Left); }
	BOOL LoadImageRight(const char *name) { return LoadImageOverlap(name, Right); }
	BOOL LoadImageCenter(const char *name) { return LoadImageOverlap(name, Center); }
	BOOL LoadImageOverlap(const char *name) { return LoadImageOverlap(name, Both); }

	void ClearBack() { ClearImageBack(); }
	void ClearCenter() { HideOverlapLayer(Center); }
	void ClearLeft() { HideOverlapLayer(Left); }
	void ClearRight() { HideOverlapLayer(Right); }
	void ClearOverlap() { HideOverlapLayer(Both); }

	const CRect &GetInvalidRect() const { return InvalidRect; }

	void Repaint(const CRect &rect);

	void UpdateImage(const CRect &rect);

  protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT &cs);

	BOOL OnCreate(CREATESTRUCT *cs);
	void OnFirstAction();
	void OnClose();
	void OnPaint();

	BOOL LoadImageOverlap(const char *name, int position);
	BOOL ClearImageBack();
	void ShowOverlapLayer(int pos);
	void HideOverlapLayer(int pos);
	BOOL Update(bool repaint=true);

	void HideAllLayer(COLORREF pix);

	int MsgX(int x) const { return x * MessageFont / 2 + MSG_TEXTOFFSET_X; }
	int MsgY(int y) const { return y * (MessageFont + MSG_TEXTSPACE_Y) + MSG_TEXTOFFSET_Y; }
	BOOL Kinsoku(const char *p);

	void Mixing(const CRect &rect, unsigned flags = ~0);

	void Invalidate(const CRect &rect) { InvalidRect |= rect; }

	int FormatMessage(const char *msg);

	BOOL IsStopScript() const { return Action->IsScriptRunning(); }

  protected:
	HFONT	hFont;						// eLXgAj[̃tHg

	CAction        *Action;				// Action
	CAction			NopAction;			// ȂANV
	CScriptAction	ScriptAction;		// XNvgsANV

	CDrawImage	MixedImage;				// 
	CImage		BackLayer;				// wi
	CImage		OverlapLayer;			// d
	unsigned	OverlapFlags;			// dˏԃtO
	BOOL		TextDisplay;			// eLXg\ĂH
	BOOL		WaitMarkShowing;		// ҂}[N\ĂH

	CRect		InvalidRect;			// ̈
	CRect		TextRect;				// eLXg̈
	CRect		WaitMarkRect;			// ҂}[N̈
	CRect		MenuRect;				// j[̈
	CRect		OverlapBounds;			// udˁv̗L̈
	BOOL		BackShow;				// wi\H
	BOOL		OverlapShow;			// d˂\H
	BOOL		TextShow;				// eLXg\H
	BOOL		MenuShow;				// j[\H
	COLORREF	BgColor;				// wiȂɓhԂF

	char	MsgBuffer[MessageLine][MessageWidth + 1];
	int		CurX;
	int		CurY;

	CMenuItem	MenuBuffer[MAX_MENU_ITEM];
	int			MenuCount;

	static const CRect Position[];
} ;

// CCo֐

//
//	[̃C[W\
//
inline void CMainWin::Repaint(const CRect &rect)
{
	MixedImage.Draw(CClientDC(this), rect);
}

//
//	ĕ`悷OɁÄ悪΃[̃C[W
//
inline void CMainWin::UpdateImage(const CRect &rect)
{
	Update();
	Repaint(rect);
}

//
//	}EX|C^̈ʒu烁j[ڂ𓾂
//
inline int CMainWin::GetMenuSelect(CPoint point)
{
	if (point.x < MenuRect.left + MENU_FRAME_WIDTH
	 || point.y < MenuRect.top + MENU_FRAME_HEIGHT
	 || point.x >= MenuRect.right - MENU_FRAME_WIDTH
	 || point.y >= MenuRect.bottom - MENU_FRAME_HEIGHT)
		return -1;
	return (point.y - MenuRect.top - MENU_FRAME_WIDTH) / MENU_ITEM_HEIGHT;
}

#endif
