//
//	XNvgRo[^
//
//		Copyright (c) 2000-2002 Chihiro.SAKAMOTO (HyperWorks)
//
#ifndef	__SCRIPTTYPES_H__
#define	__SCRIPTTYPES_H__

// R}hR[h
enum	{
	SET_VALUE_CMD,
	CALC_VALUE_CMD,
	TEXT_CMD,
	CLEAR_TEXT_CMD,
	GOTO_CMD,
	IF_TRUE_CMD,
	IF_FALSE_CMD,
	IF_BIGGER_CMD,
	IF_SMALLER_CMD,
	IF_BIGGER_EQU_CMD,
	IF_SMALLER_EQU_CMD,
	MENU_INIT_CMD,
	MENU_ITEM_CMD,
	MENU_CMD,
	EXEC_CMD,
	LOAD_CMD,
	UPDATE_CMD,
	CLEAR_CMD,
	MODE_CMD,
	SYS_EXIT_CMD,
	SYS_CLEAR_CMD,
	END_CMD,
} ;

// CG|WV
enum	{
	POSITION_BACK,
	POSITION_BACKONLY,
	POSITION_CENTER,
	POSITION_LEFT,
	POSITION_RIGHT,
	POSITION_OVERLAP,
} ;

// [htO
enum	{
	MODE_SYSTEM,
	MODE_SCENARIO,
} ;

#ifdef	_MSC_VER
#pragma pack(push, 4)
#endif

// R}ĥ݂̋ʍ\
typedef	struct	{
	unsigned char	type;
	unsigned char	size;
	char			dummy[2];
} single_cmd_t;

typedef	single_cmd_t	clear_text_t;
typedef	single_cmd_t	sys_clear_t;
typedef	single_cmd_t	end_t;

// setR}h\
typedef	struct	{
	unsigned char	type;
	unsigned char	size;
	unsigned short	value_addr;
	long			set_value;
} set_value_t;

// calcR}h\
typedef	struct	{
	unsigned char	type;
	unsigned char	size;
	unsigned short	value_addr;
	long			add_value;
} calc_value_t;

// textR}h\
typedef	struct	{
	unsigned char	type;
	unsigned char	size;
	unsigned short	msg_len;
} text_t;

// gotoR}h\
typedef	struct	{
	unsigned char	type;
	unsigned char	size;
	char			dummy[2];
	long			goto_label;
} goto_t;

// ifR}h\
typedef	struct	{
	unsigned char	type;
	unsigned char	size;
	unsigned char	flag;
	char			dummy;
	long			value1;
	long			value2;
	long			goto_label;
} if_t;

typedef	single_cmd_t	menu_init_t;

// menuR}h\
typedef	struct	{
	unsigned char	type;
	unsigned char	size;
	short			value_addr;
} menu_t;

// j[ڃR}h\
typedef	struct	{
	unsigned char	type;
	unsigned char	size;
	unsigned char	number;
	unsigned char	label_len;
} menu_item_t;

// execR}h\
typedef	struct	{
	unsigned char	type;
	unsigned char	size;
	char			dummy;
	unsigned char	path_len;
} exec_cmd_t;

// loadR}h\
typedef	struct	{
	unsigned char	type;
	unsigned char	size;
	char			flag;
	unsigned char	path_len;
} load_t;

// updateR}h\
typedef	single_cmd_t	update_t;

// clearR}h\
typedef	struct	{
	unsigned char	type;
	unsigned char	size;
	char			pos;
	char			dummy;
} clear_t;

// modeR}h\
typedef	struct	{
	unsigned char	type;
	unsigned char	size;
	char			mode;
	char			dummy;
} mode_cmd_t;

// R}h
typedef	union	{
	struct	{
		unsigned char	type;
		unsigned char	size;
	} common;
	set_value_t			set;
	calc_value_t		calc;
	text_t				text;
	clear_text_t		clear_text;
	goto_t				goto_cmd;
	if_t				if_cmd;
	menu_init_t			menu_init;
	menu_t				menu;
	menu_item_t			menu_item;
	load_t				load;
	update_t			update;
	clear_t				clear;
	exec_cmd_t			exec_cmd;
	mode_cmd_t			mode;
	end_t				end;
} command_t;

#ifdef	_MSC_VER
#pragma pack(pop)
#endif

// ő吔
#define	MAX_COMMAND		65536
#define	MAX_VALUES		100
#define	MAX_TEXTLINE	4

#define	SCRIPT_MAGIC	"[SCRIPT]"

#endif
