//
//	ʃGtFNg
//
//		Copyright (c) 2000-2002 Chihiro.SAKAMOTO (HyperWorks)
//
#include "stdafx.h"
#include <stdlib.h>
#include "ScrPlay.h"
#include "MainWin.h"
#include "Effect.h"
#include "Image.h"
#include "misc.h"

//
// new, delete ̎O
//
//	q[vł͂ȂAmۍς݂̃犄蓖Ă
//	ɂAq[vsɂG[
//
//	̂悤ȓȏĂ邽߁AfobO
//	@eXgR[h𖄂ߍł
//
static char	alloc_buffer[sizeof(CViewEffect)];
#ifdef	_DEBUG
static bool alloced = false;
#endif

void *CViewEffect::operator new(size_t size)
{
#ifdef	_DEBUG
	if (size > sizeof(alloc_buffer)) {
		TRACE("CViewEffect::AP[VTCY傫ł\n");
		ASSERT(FALSE);
	}
	if (alloced) {
		TRACE("CViewEffect::dɊmۂĂ܂\n");
		ASSERT(FALSE);
	}
	alloced = true;
#endif
	return alloc_buffer;
}

void CViewEffect::operator delete(void *ptr)
{
#ifdef	_DEBUG
	if (ptr == 0)
		return;
	ASSERT(alloced && ptr == alloc_buffer);
	alloced = false;
#endif
}

//
// GtFNg̃Xebvp
// 1XebvÂ̂́Aԑ҂邽
//
//
// CvC̃Xebv
//
bool EffectWipeIn::Step()
{
	Dst->WipeIn(Src, EffectRect, EffectCnt);
	Window->Repaint(EffectRect);

	if (++EffectCnt >= 8)
		return false;
	return true;
}

//
// CvAEg̃Xebv
//
bool EffectWipeOut::Step()
{
	Dst->WipeOut(EffectRect, EffectCnt);
	Window->Repaint(EffectRect);

	if (++EffectCnt >= 8)
		return false;
	return true;
}

//
// CvC2̃Xebv
//
bool EffectWipeIn2::Step()
{
	bool result = Dst->WipeIn2(Src, EffectRect, EffectCnt++);
	Window->Repaint(EffectRect);
	return result;
}

//
// CvAEg2̃Xebv
//
bool EffectWipeOut2::Step()
{
	bool result = Dst->WipeOut2(EffectRect, EffectCnt++);
	Window->Repaint(EffectRect);
	return result;
}

//
// tF[hC̃Xebv
//
bool EffectFadeIn::Step()
{
	Dst->FadeFromBlack(Src, EffectRect, EffectCnt);
	Window->Repaint(EffectRect);

	if (++EffectCnt >= 16)
		return false;
	return true;
}

//
// tF[hAEg̃Xebv
//
bool EffectFadeOut::Step()
{
	Dst->FadeToBlack(Src, EffectRect, EffectCnt);
	Window->Repaint(EffectRect);

	if (++EffectCnt >= 16)
		return false;
	return true;
}

//
// tF[hC()̃Xebv
//
bool EffectWhiteIn::Step()
{
	Dst->FadeFromWhite(Src, EffectRect, EffectCnt);
	Window->Repaint(EffectRect);

	if (++EffectCnt >= 16)
		return false;
	return true;
}

//
// tF[hAEg()̃Xebv
//
bool EffectWhiteOut::Step()
{
	Dst->FadeToWhite(Src, EffectRect, EffectCnt);
	Window->Repaint(EffectRect);

	if (++EffectCnt >= 16)
		return false;
	return true;
}

//
// ^C~bNX̃Xebv
//
bool EffectMixFade::Step()
{
	Dst->Mix(Src, EffectRect, EffectCnt);
	Window->Repaint(EffectRect);

	if (++EffectCnt >= 8)
		return false;
	return true;
}

//
// ʂ̏ũXebv
//
bool EffectFlash::Step()
{
	switch (EffectCnt++) {
	  case 0:	// œhԂ
		{
			CClientDC	dc(Window);
			dc.SetBkColor(RGB(255, 255, 255));
			dc.ExtTextOut(0, 0, ETO_OPAQUE, &EffectRect, 0, 0, NULL);
		}
		break;

	  case 1:	// ɖ߂
		Window->Repaint(EffectRect);
		break;

	  default:	// ꔏďÎ́AJԂƂl
		return false;
	}
	return true;
}

//
// ʂ̂̃Xebv
//
//	́AAAAAɖ߂̏
//
bool EffectShake::Step()
{
	int		x, y, w, h, ox, oy;
	CRect	rect;

	switch (EffectCnt) {
	  case 0:
	  case 2:
		x = 0;
		y = 0;
		w = WindowWidth;
		h = WindowHeight - 10;
		ox = 0;
		oy = 10;
		rect.SetRect(0, WindowHeight - 10, WindowWidth, WindowHeight);
		break;

	  case 4:
		x = 0;
		y = 0;
		w = WindowWidth;
		h = WindowHeight;
		ox = 0;
		oy = 0;
		rect.SetRect(0, 0, 0, 0);
		break;

	  case 1:
	  case 3:
		x = 0;
		y = 10;
		w = WindowWidth;
		h = WindowHeight - 10;
		ox = 0;
		oy = 0;
		rect.SetRect(0, 0, WindowWidth, 10);
		break;

	  default:
		return false;
	}

	CClientDC	dc(Window);
	Dst->Draw(dc, x, y, w, h, ox, oy);
	if (x != ox || y != oy) {
		dc.SetBkColor(RGB(0, 0, 0));
		dc.ExtTextOut(0, 0, ETO_OPAQUE, &rect, 0, 0, NULL);
	}

	if (++EffectCnt >= 5)
		return false;
	return true;
}
