//
//	[hZ[uANV
//
//		Copyright (c) 2000-2002 Chihiro.SAKAMOTO (HyperWorks)
//
#include "stdafx.h"
#include "MainWin.h"
#include "LoadSave.h"

//
// 
//
void CGameLoadSaveAction::Initialize(CMainWin *parent, unsigned param1, unsigned param2)
{
	CAction::Initialize(parent, param1, param2);

	Selection = -1;
	Pressed = FALSE;
	CancelPressed = FALSE;
	Flags = 0;
}

//
// }EX{^̏
//
void CGameLoadSaveAction::LButtonDown(UINT modKeys, CPoint point)
{
	Pressed = TRUE;
}

//
// }EX{^ꂽ̏
//
void CGameLoadSaveAction::LButtonUp(UINT modKeys, CPoint point)
{
	Pressed = FALSE;
	if (Selection >= 0)
		DoLoadSave();
}

//
// }EXE{^̏
//
void CGameLoadSaveAction::RButtonDown(UINT modKeys, CPoint point)
{
	CancelPressed = TRUE;
}

//
// }EXE{^ꂽ̏
//
void CGameLoadSaveAction::RButtonUp(UINT modKeys, CPoint point)
{
	if (CancelPressed)
		Parent->CancelLoadSaveMenu(Flags);
}

//
// }EX|C^ړ̏
//
void CGameLoadSaveAction::MouseMove(UINT modKeys, CPoint point)
{
	int sel = Parent->GetLoadSaveSelect(point);
	if (sel != Selection) {
		Parent->SelectLoadSaveMenu(Selection, false);
		Selection = sel;
		Parent->SelectLoadSaveMenu(Selection, true);
	}
}

//
// L[{[h̏
//
void CGameLoadSaveAction::KeyDown(UINT key)
{
	switch (key) {
	  case VK_RETURN:
	  case VK_SPACE:	// [hZ[u̎s
		if (Selection >= 0)
			DoLoadSave();
		break;

	  case VK_ESCAPE:	// LZ
		Parent->CancelLoadSaveMenu(Flags);
		break;

	  case VK_UP:		// OڑI
		{
			int		sel = Parent->PrevLoadSaveSelect(Selection);
			if (sel != Selection) {
				Parent->SelectLoadSaveMenu(Selection, false);
				Selection = sel;
				Parent->SelectLoadSaveMenu(Selection, true);
			}
		}
		break;

	  case VK_DOWN:		// ڑI
		{
			int		sel = Parent->NextLoadSaveSelect(Selection);
			if (sel != Selection) {
				Parent->SelectLoadSaveMenu(Selection, false);
				Selection = sel;
				Parent->SelectLoadSaveMenu(Selection, true);
			}
		}
		break;
	}
}

//
// ^C}[̏
//
void CGameLoadSaveAction::TimedOut(int timerId)
{
	switch (timerId) {
	  case CMainWin::TimerSleep:
		Flags |= CMainWin::IS_TIMEDOUT;
		break;
	}
}

//
// Q[̃[h
//
void CGameLoadAction::DoLoadSave()
{
	Parent->LoadGame(Selection);
}

//
// Q[̃Z[u
//
void CGameSaveAction::DoLoadSave()
{
	Parent->SaveGame(Selection, Flags);
}
