//
//	XNvgv[[CEChE
//
//		Copyright (c) 2000-2002 Chihiro.SAKAMOTO (HyperWorks)
//
#ifndef __MainWin_h__
#define __MainWin_h__

#include "Window.h"
#include "dc.h"
#include "Action.h"
#include "Script.h"
#include "Image.h"
#include "DrawImage.h"
#include "LoadSave.h"
#include "Effect.h"
#include "Mci.h"
#include "Params.h"

//
//	CEChENX
//
class CMainWin: public CWindow {
  public:
	// 萔

	// ANV
	enum	{
		ActionNop,
		ActionScriptDone,
		ActionScriptSetup,
		ActionScript,
		ActionGameLoad,
		ActionGameSave,
	} ;

	// y[h
	enum	{
		MusicCD,
		MusicOff,
	} ;

	// ^C}[ID
	enum	{
		TimerSleep,
	} ;

	// ҋ@̃CxgtO
	enum	{
		IS_TIMEDOUT = (1 << 0),
	} ;

	// ڍő吔
	enum	{
		MAX_MENU_ITEM = 8,
		MAX_MENU_TEXT = 60,
		MAX_SAVE_TEXT = 62,
	} ;

  protected:
	// I[o[bv̕\ʒu
	enum	{
		None = 0,
		Left = 1,
		Right = 2,
		Both = 3,
		Center = 4,
	} ;

	// bZ[W\ʒu
	enum	{
		MSG_W = MessageFont * MessageWidth / 2 + 20,
		MSG_H = (MessageFont + 2) * MessageLine + 14,
		MSG_X = (WindowWidth - MSG_W) / 2,
		MSG_Y = WindowHeight - MSG_H - 8,
		MSG_TEXTOFFSET_X = MSG_X + 10,
		MSG_TEXTOFFSET_Y = MSG_Y + 7,
		MSG_TEXTSPACE_Y = 2,
		WAITMARK_X = MessageWidth - 2,
		WAITMARK_Y = MessageLine - 1,
	} ;

	// j[\ʒu
	enum	{
		MENU_X = 20,
		MENU_Y = MSG_Y - 2,		// bZ[ẄɏdȂȂ悤
		MENU_WIDTH = (MAX_MENU_TEXT + 2) * MessageFont / 2,
		MENU_HEIGHT = (MAX_MENU_ITEM + 1) * MessageFont,
		MENU_MIN_WIDTH = 50,
		MENU_FRAME_WIDTH = 10,
		MENU_FRAME_HEIGHT = 10,
		MENU_ITEM_SPACE = 2,
		MENU_ITEM_HEIGHT = MessageFont + MENU_ITEM_SPACE,
	} ;

	// Z[u[hj[\ʒu
	enum	{
		SAVE_ITEM_HEIGHT = 32,
		SAVE_ITEM_SPACE = 4,
		SAVE_ITEM_INTERVAL = SAVE_ITEM_HEIGHT + SAVE_ITEM_SPACE,
		SAVE_W = 400,
		SAVE_H = SAVE_ITEM_INTERVAL * PARAMS_MAX_SAVE + SAVE_ITEM_HEIGHT,
		SAVE_X = (WindowWidth - SAVE_W) / 2,
		SAVE_Y = (WindowHeight - SAVE_H) / 2,
		SAVE_TEXT_OFFSET_X = SAVE_X + 10,
		SAVE_TEXT_OFFSET_Y = SAVE_Y + 8,
		SAVE_TITLE_WIDTH = 72,
	} ;

	// j[
	struct CMenuItem {
		char		text[MAX_MENU_TEXT];
		int			anser;
		int			length;
		COLORREF	color;
	} ;

	// ʍ
	enum	{
		TextMessage = 1 << 0,
		TextWaitMark = 1 << 1,
		MenuFrame = 1 << 2,
		SaveTitle = 1 << 3,
		MenuItemFirst = 4,
		SaveItemFirst = 12,
	} ;
	static unsigned MenuItem(int n) { return 1 << (MenuItemFirst + n); }
	static unsigned SaveItem(int n) { return 1 << (SaveItemFirst + n); }

  public:
	CMainWin();
	~CMainWin();

	LRESULT WindowProc(UINT uMsg, WPARAM wParam, LPARAM lParam);

	virtual void OnInitSubMenu(HMENU hMenu, UINT id);
	virtual BOOL OnIdle(long count);

	void OnCommand(UINT notifyCode, UINT id, HWND ctrl);

	BOOL SetAction(int action, int param=0);
	bool StartScript(const char *name, int mode=0);
	void StartMainMenu();

	void WriteMessage(const char *msg);
	void ClearMessage();
	void HideWaitMark();
	void ShowMessageWindow();
	void HideMessageWindow(bool update=true);
	void FlipMessageWindow();

	void SetMenuItem(const char *lavel, int anser);
	void OpenMenu();
	void HideMenuWindow(bool update=true);
	void ClearMenuItemCount() { MenuCount = 0; }
	int GetMenuItemCount() const { return MenuCount; }
	int GetMenuAnser(int index) const { return MenuBuffer[index].anser; }
	int GetMenuSelect(CPoint point);
	void SelectMenu(int index, bool select);

	BOOL LoadImageBack(const char *name);
	BOOL LoadImageLeft(const char *name) { return LoadImageOverlap(name, Left); }
	BOOL LoadImageRight(const char *name) { return LoadImageOverlap(name, Right); }
	BOOL LoadImageCenter(const char *name) { return LoadImageOverlap(name, Center); }
	BOOL LoadImageOverlap(const char *name) { return LoadImageOverlap(name, Both); }

	void ClearBack() { ClearImageBack(); }
	void ClearCenter() { HideOverlapLayer(Center); }
	void ClearLeft() { HideOverlapLayer(Left); }
	void ClearRight() { HideOverlapLayer(Right); }
	void ClearOverlap() { HideOverlapLayer(Both); }

	const CRect &GetInvalidRect() const { return InvalidRect; }

	void Repaint(const CRect &rect);
	void CopyAndRepaint(const CRect &rect);

	BOOL StartMusic(int no);
	BOOL RestartMusic();
	BOOL StopMusic();
	BOOL StartWave(const char *name);

	void ShowLoadSaveMenu(BOOL isSave);
	void CancelLoadSaveMenu(int flags);
	int GetLoadSaveSelect(CPoint point);
	int NextLoadSaveSelect(int index);
	int PrevLoadSaveSelect(int index);
	void SelectLoadSaveMenu(int index, bool select);

	void WipeIn(int pattern=1);
	void WipeOut(int pattern=1);
	void FadeIn();
	void FadeOut();
	void CutIn();
	void CutOut(BOOL white);
	void WhiteIn();
	void WhiteOut();
	void CutIn(const CRect &rect);
	void WipeIn(const CRect &rect, int pattern=1);
	void MixFade(const CRect &rect);
	void Flash();
	void Shake();

	void LoadGame(int no);
	void SaveGame(int no, int flags);

  protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT &cs);

	BOOL OnCreate(CREATESTRUCT *cs);
	void OnFirstAction();
	void OnClose();
	void OnPaint();
	void OnDestroy();
	void OnTimer(int id);

	void OnMciNotify(unsigned flag, unsigned id);

	void ChangeMusicMode(int mode);

	BOOL IsLoadOK() const;
	BOOL IsSaveOK() const;

	BOOL LoadImageOverlap(const char *name, int position);
	BOOL ClearImageBack();
	void ShowOverlapLayer(int pos);
	void HideOverlapLayer(int pos);
	BOOL Update(bool repaint=true);

	void HideAllLayer(COLORREF pix);

	int MsgX(int x) const { return x * MessageFont / 2 + MSG_TEXTOFFSET_X; }
	int MsgY(int y) const { return y * (MessageFont + MSG_TEXTSPACE_Y) + MSG_TEXTOFFSET_Y; }
	BOOL Kinsoku(const char *p);

	void Mixing(const CRect &rect, unsigned flags = ~0);

	void Invalidate(const CRect &rect) { InvalidRect |= rect; }

	int FormatMessage(const char *msg);

	void ShowLoadSaveMenu(BOOL isSave, CRect *rect);
	void HideLoadSaveMenu();

	void StopWipe();

  protected:
	HFONT	hFont;						// eLXgAj[̃tHg

	int		MusicMode;					// BGM̉t[h

	CMci   *music;						// BGMtfoCX
	CDAudio	cdaudio;					// CD-DAtNX
	int		MusicNo;					// t̋Ȕԍ
	WaveOut	wave;						// WaveĐ

	CParams		LoadParam;				// u[hvp[^

	CAction        *Action;				// Action
	CAction			NopAction;			// ȂANV
	CScriptAction	ScriptAction;		// XNvgsANV
	CGameLoadAction	GameLoadAction;		// Q[[hANV
	CGameSaveAction	GameSaveAction;		// Q[Z[uANV

	CDrawImage	ViewImage;				// \
	CDrawImage	MixedImage;				// 
	CImage		BackLayer;				// wi
	CImage		OverlapLayer;			// d
	unsigned	OverlapFlags;			// dˏԃtO
	BOOL		TextDisplay;			// eLXg\ĂH
	BOOL		WaitMarkShowing;		// ҂}[N\ĂH

	CRect		InvalidRect;			// ̈
	CRect		TextRect;				// eLXg̈
	CRect		WaitMarkRect;			// ҂}[N̈
	CRect		MenuRect;				// j[̈
	CRect		OverlapBounds;			// udˁv̗L̈
	BOOL		BackShow;				// wi\H
	BOOL		OverlapShow;			// d˂\H
	BOOL		TextShow;				// eLXg\H
	BOOL		MenuShow;				// j[\H
	BOOL		SaveShow;				// Z[u/[h\H
	CRect		SaveRect;				// Z[u/[ḧ
	COLORREF	BgColor;				// wiȂɓhԂF

	CViewEffect *ViewEffect;			// GtFNg
	UINT		TimePeriod;				// ^C}[̕\

	char	MsgBuffer[MessageLine][MessageWidth + 1];
	int		CurX;
	int		CurY;

	CMenuItem	MenuBuffer[MAX_MENU_ITEM];
	int			MenuCount;

	BOOL	IsSaveMenu;
	struct	{
		bool		activate;
		char		title[MAX_SAVE_TEXT + 1];
		COLORREF	color;
	} DataTitle[PARAMS_MAX_SAVE];

	static const CRect Position[];
} ;

// CCo֐

//
//	[̃C[W\
//
inline void CMainWin::Repaint(const CRect &rect)
{
	ViewImage.Draw(CClientDC(this), rect);
}

//
//	pC[WA\pC[Wɕʂĕ\
//
inline void CMainWin::CopyAndRepaint(const CRect &rect)
{
	ViewImage.Copy(&MixedImage, rect);
	Repaint(rect);
}

//
//	}EX|C^̈ʒu烁j[ڂ𓾂
//
inline int CMainWin::GetMenuSelect(CPoint point)
{
	if (point.x < MenuRect.left + MENU_FRAME_WIDTH
	 || point.y < MenuRect.top + MENU_FRAME_HEIGHT
	 || point.x >= MenuRect.right - MENU_FRAME_WIDTH
	 || point.y >= MenuRect.bottom - MENU_FRAME_HEIGHT)
		return -1;
	return (point.y - MenuRect.top - MENU_FRAME_WIDTH) / MENU_ITEM_HEIGHT;
}

//
//	CvC
//
inline void CMainWin::WipeIn(const CRect &rect, int pattern)
{
	Update(false);
	switch (pattern) {
	  case 1:
		ViewEffect = new EffectWipeIn(this, &ViewImage, &MixedImage, rect);
		break;

	  default:
		ViewEffect = new EffectWipeIn2(this, &ViewImage, &MixedImage, rect);
		break;
	}
}

//
//	CvC
//
inline void CMainWin::WipeIn(int pattern)
{
	WipeIn(CRect(0, 0, WindowWidth, WindowHeight), pattern);
}

//
//	CvAEg
//
inline void CMainWin::WipeOut(int pattern)
{
	HideMessageWindow();
	switch (pattern) {
	  case 1:
		ViewEffect = new EffectWipeOut(this, &ViewImage, &MixedImage);
		break;

	  default:
		ViewEffect = new EffectWipeOut2(this, &ViewImage, &MixedImage);
		break;
	}
	HideAllLayer(BlackPixel);
}

//
//	tF[hC
//
inline void CMainWin::FadeIn()
{
	Update(false);
	ViewEffect = new EffectFadeIn(this, &ViewImage, &MixedImage);
}

//
//	tF[hAEg
//
inline void CMainWin::FadeOut()
{
	HideMessageWindow();
	ViewEffect = new EffectFadeOut(this, &ViewImage, &MixedImage);
	HideAllLayer(BlackPixel);
}

//
//	JbgC
//
inline void CMainWin::CutIn(const CRect &rect)
{
	Update(false);
	CopyAndRepaint(rect);
}

//
//	JbgC
//
inline void CMainWin::CutIn()
{
	CutIn(CRect(0, 0, WindowWidth, WindowHeight));
}

//
//	JbgAEg
//
inline void CMainWin::CutOut(BOOL white)
{
	HideMessageWindow();
	HideAllLayer(white? WhitePixel: BlackPixel);
	Invalidate(Position[Both]);
	Update();
}

//
//	tF[hCij
//
inline void CMainWin::WhiteIn()
{
	Update(false);
	ViewEffect = new EffectWhiteIn(this, &ViewImage, &MixedImage);
}

//
//	tF[hAEgij
//
inline void CMainWin::WhiteOut()
{
	HideMessageWindow();
	ViewEffect = new EffectWhiteOut(this, &ViewImage, &MixedImage);
	HideAllLayer(WhitePixel);
}

//
//	^Cp^[tF[h
//
inline void CMainWin::MixFade(const CRect &rect)
{
	Update(false);
	ViewEffect = new EffectMixFade(this, &ViewImage, &MixedImage, rect);
}

//
//	ʂ̂
//
inline void CMainWin::Shake()
{
	ViewEffect = new EffectShake(this, &ViewImage);
}

//
//	ʂ̃tbV
//
inline void CMainWin::Flash()
{
	ViewEffect = new EffectFlash(this, &ViewImage);
}

//
//	GtFNg̒~
//
inline void CMainWin::StopWipe()
{
	delete ViewEffect;
	ViewEffect = 0;
}

//
//	[h\H
//
inline BOOL CMainWin::IsLoadOK() const
{
	return Action->IsScriptRunning() && ScriptAction.IsSaveLoadOK();
}

//
//	Z[u\H
//
inline BOOL CMainWin::IsSaveOK() const
{
	return Action->IsScriptRunning() && ScriptAction.IsSaveLoadOK();
}

#endif
