//
//	MCI NX/CD-DA/Wave NX
//
//		Copyright (c) 2000-2002 Chihiro.SAKAMOTO (HyperWorks)
//
#include "stdafx.h"
#include "Mci.h"
#include "Window.h"
#include "Misc.h"

//
// I[v
//
bool CMci::Open(CWindow *window)
{
	Window = window;

	return true;
}

//
// N[Y
//
bool CMci::Close()
{
	return true;
}

//
// t(Ȕԍ)
//
bool CMci::Play(int no)
{
	return false;
}

//
// t(t@C)
//
bool CMci::Play(const char *name)
{
	return false;
}

//
// ĉt
//
bool CMci::Replay()
{
	return false;
}

//
// ~
//
bool CMci::Stop()
{
	return false;
}

//
// G[bZ[W̕\
//
void CMci::MciErrorMessageBox(DWORD err)
{
	char	errstr[256];
	mciGetErrorString(err, errstr, sizeof(errstr));
	Window->MessageBox(errstr, errTitle);
}

//
// MCIopenR}hs
//
bool CMci::MciOpen(const char *command)
{
	DWORD err;
	char	result[128];
	if ((err = mciSendString(command, result, sizeof(result), 0)) != 0) {
		MciErrorMessageBox(err);
		return false;
	}

	char *p;
	Id = strtol(result, &p, 0);

	return true;
}

//
// MCIopenR}hs
//
bool CMci::MciOpen()
{
	char	command[128];
	sprintf(command, "open %s wait", device);
	return MciOpen(command);
}

//
// MCIopenR}hs
//
bool CMci::MciOpen(const char *dev, const char *element)
{
	char	command[_MAX_PATH + 128];
	sprintf(command, "open \"%s!%s\" alias %s wait", dev, element, device);
	return MciOpen(command);
}

//
// MCIcloseR}hs
//
bool CMci::MciClose()
{
	Id = 0;

	char	command[128];
	sprintf(command, "close %s wait", device);
	if (mciSendString(command, NULL, 0, 0) != 0)
		return false;
	return true;
}

//
// MCIplayR}hs
//
bool CMci::MciPlay(const char *request)
{
	char	command[256];
	sprintf(command, "play %s %s notify", device, request);

	DWORD	err;
	if ((err = mciSendString(command, NULL, 0, *Window)) != 0) {
		MciErrorMessageBox(err);
		return false;
	}
	return true;
}

//
// MCIstopR}hs
//
bool CMci::MciStop()
{
	char	command[128];
	sprintf(command, "stop %s wait", device);
	if (mciSendString(command, NULL, 0, 0) != 0)
		return false;
	return true;
}

//
// MCIsetR}hs
//
bool CMci::MciSet(const char *request)
{
	char	command[128];
	sprintf(command, "set %s %s wait", device, request);

	DWORD	err;
	if ((err = mciSendString(command, NULL, 0, 0)) != 0) {
		MciErrorMessageBox(err);
		return false;
	}
	return true;
}

//
// MCIstatusR}hs
//
bool CMci::MciStatus(const char *request, char *result, int resultlen)
{
	char	command[128];
	sprintf(command, "status %s %s wait", device, request);

	DWORD err;
	if ((err = mciSendString(command, result, resultlen, 0)) != 0) {
		MciErrorMessageBox(err);
		return false;
	}
	return true;
}

//
// CDhCuɃfBA邩H
//
int CDAudio::MediaChk()
{
	char	result[128];
	if (!MciStatus("media present", result, sizeof(result)))
		return -1;
	if (stricmp(result, "true") == 0)
		return 0;
	return 1;
}

//
// CD̃I[v
//
bool CDAudio::Open(CWindow *win)
{
	CMci::Open(win);

	if (!MciOpen())
		return false;

	if (!MciSet("time format tmsf")) {
		MciClose();
		return false;
	}

	bool chkOk = false;

	do {
		switch (MediaChk()) {
		  case -1:
			MciClose();
			return false;

		  case 0:
			chkOk = true;
			break;

		  default:
#ifdef	notdef		// bcĂȂɃG[ɂꍇ #ifdef -> #ifndef ɕύX
					// ԈႢȂAf[^gbNɁuʗpt@CvĂ
					// `FbNƗǂł傤
			if (Window->MessageBox(ApplicationTitle "bchCuɓĂB",
				ApplicationTitle, MB_RETRYCANCEL) == IDCANCEL) {
				MciClose();
				return false;
			}
			break;
#else
			MciClose();
			return false;
#endif
		}
	} while (!chkOk) ;

	IsOpen = true;

	return true;
}

//
// CD̃N[Y
//
bool CDAudio::Close()
{
	if (IsOpen) {
		Stop();
		MciClose();
	}
	IsOpen = false;
	return true;
}

//
// CD̉tJniw肵gbN̂݁j
//
bool CDAudio::Play(int no)
{
	if (!IsOpen)
		return false;

	Stop();
	PlayTrack = no;

	no++;		// MixedCD{ɂĂ̂ŁAPgbNt

	// gbN̒𒲂ׂ
	// ͈̔͂tw

	char	request[64];
	sprintf(request, "length track %d", no);

	char	result[128];
	if (!MciStatus(request, result, sizeof(result)))
		return false;

	sprintf(request, "from %d:00:00:00 to %d:%s", no, no, result);
	if (!MciPlay(request))
		return false;
	return true;
}

//
// CD̉tJnit@CẃAKG[ɂȂj
//
bool CDAudio::Play(const char *)
{
	return false;
}

//
// CD̍ĉt
//
bool CDAudio::Replay()
{
	return Play(PlayTrack);
}

//
// CD̉t~
//
bool CDAudio::Stop()
{
	if (!IsOpen)
		return false;

	if (PlayTrack > 0) {
		MciStop();
		PlayTrack = 0;
	}
	return true;
}

//
// Wave̍Đ
//
bool WaveOut::Play(const char *name)
{
	Stop();

	// tpX߂
	char	fullpath[_MAX_PATH];
	FullPath(fullpath, name);

	if (!MciOpen("waveaudio", fullpath))
		return false;

	if (!MciPlay(""))
		return false;

	playing = true;

	return true;
}

//
// Wave̍Đij
//
bool WaveOut::Play(int)
{
	return false;
}

//
// Wave̍Đ~
//
bool WaveOut::Stop()
{
	if (playing) {
		playing = false;
		MciStop();
		MciClose();
	}
	return true;
}
