//
//	MCI NX/CD-DA/Wave NX
//
//		Copyright (c) 2000-2002 Chihiro.SAKAMOTO (HyperWorks)
//
#ifndef __MUSIC_H__
#define __MUSIC_H__

class CWindow;

//
//	MCINX
//
class CMci	{
  public:
	CMci(const char *_device, const char *_errTitle);
	~CMci();

	virtual bool Open(CWindow *win);
	virtual bool Close();

	virtual bool Play(int no);
	virtual bool Play(const char *name);
	virtual bool Replay();
	virtual bool Stop();

	DWORD GetId() const { return Id; }

  protected:
	void MciErrorMessageBox(DWORD err);
	bool MciOpen(const char *command);
	bool MciOpen();
	bool MciOpen(const char *dev, const char *element);
	bool MciClose();
	bool MciPlay(const char *request);
	bool MciStop();
	bool MciSet(const char *request);
	bool MciStatus(const char *request, char *result, int resultlen);

  protected:
	CWindow *Window;
	const char *device;
	const char *errTitle;
	DWORD	Id;
} ;

//	CCo֐

inline CMci::CMci(const char *_device, const char *_errTitle)
	: Id(0), device(_device), errTitle(_errTitle)
{
}

inline CMci::~CMci()
{
	Close();
}

//
//	CDI[fBINX
//
class CDAudio: public CMci {
  public:
	CDAudio(): CMci("cdaudio", "bcI[fBĨG["), IsOpen(false), PlayTrack(0) {}

	virtual bool Open(CWindow *win);
	virtual bool Close();

	virtual bool Play(const char *name);
	virtual bool Play(int no);
	virtual bool Replay();
	virtual bool Stop();

  protected:
	int MediaChk();

  protected:
	int		PlayTrack;
	bool	IsOpen;
} ;

//
//	WaveNX
//
class WaveOut: public CMci {
  public:
	WaveOut(): CMci("sound", "EG[uI[fBĨG["), playing(false) {}

	virtual bool Play(const char *name);
	virtual bool Play(int no);
	virtual bool Stop();

  protected:
	bool	playing;
} ;

#endif
