<?php
require_once('Mail/mimeDecode.php');

class ReceiptMailDecoder {

	var $_decoder;

	var $body = array( 'text'=> null , 'html'=> null );
	
	/**
	 * Ytt@C
	 * 
	 * @var array array[] = array('mime_type'=>{mime_type},
	 *							  'file_name'=>{file_name},
	 *							  'binary'=>{binary} )
	 */
	var $attachments = array();
	
	/**
	 * RXgN^
	 * 
	 * @param string $raw_mail M̂܂܃[
	 */
	function ReceiptMailDecoder ( &$raw_mail ) {
		if ( !is_null( $raw_mail ) ) {
			$this->_decode( $raw_mail );
		}
	}
	
	function init() {

	}
	
	/**
	 * [fR[hăvpeBɑ
	 * 
	 * @access public
	 * @param  string $raw_mail M̂܂܃[
	 */
	function _decode ( &$raw_mail ) {

		if ( is_null($raw_mail) ) {
			return false;
		}
		
		$params = array();
		$params['include_bodies'] = true;
		$params['decode_bodies']  = true;
		$params['decode_headers']  = true;
		// $params['input'] = $raw_mail."\n";
		
		/*
		 * Mail_mime::Decode ĕ͂
		 * }`p[g̏ꍇ́A{ƓYtɕ܂B
		 */
		$this->_decoder =& new Mail_mimeDecode( $raw_mail."\n" );
		$this->_decoder = $this->_decoder->decode($params);
		
		$this->_decodeMultiPart($this->_decoder);
	}
	
	/**
	 * wwb_̎擾
	 * 
	 * @access public
	 * @param  string  $header_name
	 * @return string
	 */
	function getRawHeader ( $header_name ) {
		return isset($this->_decoder->headers["$header_name"]) ? $this->_decoder->headers["$header_name"] : null;
	}
	
	/**
	 * wb_mimeGR[hĂꍇ̓fR[hĎ擾B
	 * 
	 * @todo   gъGɂ͑ΉĂȂB
	 * @access public
	 * @param  string $header_name
	 * @return string
	 */
	function getDecodedHeader( $header_name ) {
		return mb_decode_mimeheader($this->getRawHeader( $header_name ));
	}

	/**
	 * ̎擾 (R[hꎞIUTF-8ɕϊďs)
	 */
	function getSubject() {

		$enco = mb_internal_encoding();

		mb_internal_encoding("UTF-8");
		$sub = $this->decode_mimeheader($this->_decoder->headers["subject"]);
		mb_internal_encoding($enco);

		return $sub;
	}
	
/*
	function decodeSubject($str) {
		$decode_str = '';
		foreach (preg_split('/\s/', $str) as $split_str) {
			if (strlen($split_str) === 0) {    continue;   }

			if (preg_match('/=\?([^\?]+)\?([^\?]+)\?([^\?]+)\?=$/', $split_str, $matches)) {
			if (strtolower($matches[1]) === 'iso-2022-jp') {
			$match_decode = null;
			switch (strtoupper($matches[2])) {
			case 'B':
			$match_decode = base64_decode($matches[3]);
			break;
			case 'Q':
			$match_decode = quoted_printable_decode($matches[3]);
			break;
			}
			if (!is_null($match_decode)) {
			$decode_str .= mb_convert_encoding(
			$match_decode, mb_internal_encoding(), 'iso-2022-jp-ms'
			);
			continue;
			}
			}
			}
			$decode_str .= mb_decode_mimeheader($split_str);
		}
		return $decode_str;
	}
*/

	function decode_mimeheader($str) {
	  // ϊGR[fBOݒ
		$enc_r = array(
				'iso-2022-jp' => 'iso-2022-jp-ms' ,
				'shift_jis'   => 'sjis-win'       ,
				'euc-jp'      => 'eucjp-win'      ,
				'utf-8'       => 'utf-8'
		);
		
		$str = str_replace('?==?' , "?=\n=?" , $str);

		// s΍
		$decode_str = '';

		foreach (preg_split('/\s/', $str) as $split_str) {

			// SPACEŕ
			if (strlen($split_str) === 0) {
				$decode_str .= ($decode_str != '' ? ' ' : '');
				continue;
			}

			if (preg_match('/(.*?)=\?([^\?]+)\?([^\?]+)\?([^\?]+)\?=(.*?)$/', $split_str, $matches)) {

				// =?[Charset]?[Text]?=`̏ꍇ
				$enc_str  = strtolower($matches[2]);
				$from_enc = isset($enc_r[$enc_str]) ? $enc_r[$enc_str] : $enc_str;

				if ($from_enc != '') {

					$match_decode = null;
					switch (strtoupper($matches[3])) {
						case 'B':
							$match_decode = base64_decode($matches[4]);
							break;
						case 'Q':
							$match_decode = quoted_printable_decode($matches[4]);
							break;
					}

					if (!is_null($match_decode)) {
						// ϊɐꍇ̂ݕϊeLXgǉ̍s
						$decode_str .= ($decode_str != '' ? ' ' : '') . mb_convert_encoding( $matches[1].$match_decode.$matches[5], mb_internal_encoding(), $from_enc );
						continue;
					}
				}
			}

			// ϊłȂꍇA =?[Charset]?[Text]?= `łȂꍇ́AeLXg̃LN^Zbgoĕϊ
			$decode_str .= ($decode_str != '' ? ' ' : '') . mb_convert_encoding( $split_str , mb_internal_encoding() , $this->detect_encoding_ja( $split_str ) );
		}

		return $decode_str;
	}


	/**
	 * {ꕶ̕R[h(ASCII/JIS/eucJP-win/SJIS-win/UTF-8 ̂)
	 */
	function detect_encoding_ja( $str ) {

		$enc = @mb_detect_encoding( $str, 'ASCII,JIS,eucJP-win,SJIS-win,UTF-8' );

		switch ( $enc ) {
		case FALSE	 :
		case 'ASCII' : 
		case 'JIS'	 : 
		case 'UTF-8' : break;
		case 'eucJP-win' :
			//  eucJP-win oꍇAeucJP-win ƂĔ
			if ( @mb_detect_encoding( $str, 'SJIS-win,UTF-8,eucJP-win' ) === 'eucJP-win' ) {
				break;
			}
			$_hint = "\xbf\xfd" . $str; // "\xbf\xfd" : EUC-JP ""

			// EUC-JP -> UTF-8 ϊɃ}bsOύX镶폜(    Ȃ)
			mb_regex_encoding( 'EUC-JP' );
			$_hint = mb_ereg_replace( "\xad(?:\xe2|\xf5|\xf6|\xf7|\xfa|\xfb|\xfc|\xf0|\xf1|\xf2)", '', $_hint );

			$_tmp  = mb_convert_encoding( $_hint, 'UTF-8', 'eucJP-win' );
			$_tmp2 = mb_convert_encoding( $_tmp,  'eucJP-win', 'UTF-8' );
			if ( $_tmp2 === $_hint ) {

				// O( EUC-JP ȊOƔF͈ )
				if (
					// SJIS ƏdȂ͈(2oCg|3oCg|i[hG|1oCg)
					! preg_match( '/^(?:'
						. '[\x8E\xE0-\xE9][\x80-\xFC]|\xEA[\x80-\xA4]|'
						. '\x8F[\xB0-\xEF][\xE0-\xEF][\x40-\x7F]|'
						. '\xF8[\x9F-\xFC]|\xF9[\x40-\x49\x50-\x52\x55-\x57\x5B-\x5E\x72-\x7E\x80-\xB0\xB1-\xFC]|'
						. '[\x00-\x7E]'
						. ')+$/', $str ) && 

					// UTF-8 ƏdȂ͈(Spp||1oCg)
					! preg_match( '/^(?:'
						. '\xEF\xBC[\xA1-\xBA]|[\x00-\x7E]|'
						. '[\xE4-\xE9][\x8E-\x8F\xA1-\xBF][\x8F\xA0-\xEF]|'
						. '[\x00-\x7E]'
						. ')+$/', $str )
				) {
					// ͈̔͂ɓȂꍇ́AeucJP-win ƂČo
					break;
				}
				// O2(ꕔ̕px̑ȏn eucJP-win ƂĔ)
				// (||||||N||KN|x)
				if ( mb_ereg( '^(?:'
					. '\xE0\xDD\xE0\xEA|\xE0\xE8\xE0\xE1|\xE0\xF5\xE0\xEF|\xE1\xF2\xE1\xFB|'
					. '\xE2\xFB\xE2\xF5|\xE6\xCE\xE2\xF1|\xE7\xAF\xE6\xF9|\xE8\xE7\xE8\xEA|'
					. '\xE9\xAC\xE9\xAF|\xE9\xF1\xE9\xD9|[\x00-\x7E]'
					. ')+$', $str )
				) {
					break;
				}
			}

		default :
			//  SJIS-win Ɣfꂽꍇ́AR[h SJIS-win ƂĔ
			$enc = @mb_detect_encoding( $str, 'UTF-8,SJIS-win' );
			if ( $enc === 'SJIS-win' ) {
				break;
			}
			// ftHgƂ SJIS-win ݒ
			$enc   = 'SJIS-win';

			$_hint = "\xe9\x9b\x80" . $str; // "\xe9\x9b\x80" : UTF-8 ""

			// ϊɃ}bsOύX镶𒲐
			mb_regex_encoding( 'UTF-8' );
			$_hint = mb_ereg_replace( "\xe3\x80\x9c", "\xef\xbd\x9e", $_hint );
			$_hint = mb_ereg_replace( "\xe2\x88\x92", "\xe3\x83\xbc", $_hint );
			$_hint = mb_ereg_replace( "\xe2\x80\x96", "\xe2\x88\xa5", $_hint );

			$_tmp  = mb_convert_encoding( $_hint, 'SJIS-win', 'UTF-8' );
			$_tmp2 = mb_convert_encoding( $_tmp,  'UTF-8', 'SJIS-win' );

			if ( $_tmp2 === $_hint ) {
				$enc = 'UTF-8';
			}
			// UTF-8  SJIS 2dȂ͈͂ւ̑Ώ(SJIS D)
			if ( preg_match( '/^(?:[\xE4-\xE9][\x80-\xBF][\x80-\x9F][\x00-\x7F])+/', $str ) ) {
				$enc = 'SJIS-win';
			}
		}
		return $enc;
	}
	
	/**
	 * wwb_E-mailAhX𔲂oĕԂ
	 * 
	 * @access public
	 * @param  string $header_name
	 * @return string
	 * @see extractionEmails()
	 */
	function getHeaderAddresses ( $header_name ) {
		return $this->extractionEmails($this->getRawHeader( $header_name ));
	}
	
	/**
	 * STATIC
	 * ̒emailAhXۂ̂𒊏oĕԂ܂B
	 * emailAhXۂ̂̐K\炽߂
	 * see. http://red.ribbon.to/~php/memo_003.php
	 * 
	 * @access public
	 * @param  string $raw_string
	 * @return string $mail_addresses [AhXۂ̂𕡐,(J})؂
	 */
	function extractionEmails( $raw_string ) {

		/*
		 * emailAhXۂK\
		 * see. http://red.ribbon.to/~php/memo_003.php
		 */
		$email_regex_pattern = '/(?:[^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff]+(?![^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff])|"[^\\\\\x80-\xff\n\015"]*(?:\\\\[^\x80-\xff][^\\\\\x80-\xff\n\015"]*)*")(?:\.(?:[^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff]+(?![^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff])|"[^\\\\\x80-\xff\n\015"]*(?:\\\\[^\x80-\xff][^\\\\\x80-\xff\n\015"]*)*"))*@(?:[^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff]+(?![^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff])|\[(?:[^\\\\\x80-\xff\n\015\[\]]|\\\\[^\x80-\xff])*\])(?:\.(?:[^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff]+(?![^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff])|\[(?:[^\\\\\x80-\xff\n\015\[\]]|\\\\[^\x80-\xff])*\]))*/';
		
		if ( preg_match_all( $email_regex_pattern, $raw_string, $matches, PREG_PATTERN_ORDER ) ) {
			if ( isset($matches[0]) ) {
				return implode( ",", $matches[0] );
			}
		}
		
		return null;
	}
	
	/**
	 * fR[h{̎擾
	 * 
	 * $this->body['text']; // eLXg`̖{
	 * $this->body['html']; // html`̖{
	 */
	
	/**
	 * Ytt@C̎擾
	 * 
	 * $this->attachments[$i]['mime_type']; // MimeType
	 * $this->attachments[$i]['file_name']; // t@C
	 * $this->attachments[$i]['binary'];	// t@C{
	 */
	
	/**
	 * [{̏
	 * }`p[g̏ꍇ́Ȁ܂B
	 * 
	 * @access private
	 */
	function _decodeMultiPart(&$decoder) {
	
	// }`p[g̏ꍇ ꂼꂪpartszɍĔzuĂ̂
	// ċAIɏB
	if ( !empty($decoder->parts) ) {
		foreach ( $decoder->parts as $part ) {
		$this->_decodeMultiPart($part);
		}
	} else {
		
		if ( !empty($decoder->body) ) {
		
		// { (text or html )
		if ( 'text' === strToLower($decoder->ctype_primary) ) {
			if ( 'plain' === strToLower($decoder->ctype_secondary) ) {
			$this->body['text'] =& $decoder->body;
			}
			elseif ( 'html' === strToLower($decoder->ctype_secondary) ) {
			$this->body['html'] =& $decoder->body;
			}
			// ̑textn}`p[g
			else {
			$this->attachments[] = array( 'mime_type'=>$decoder->ctype_primary.'/'.$decoder->ctype_secondary,
							  'file_name'=>$decoder->ctype_parameters['name'],
							  'binary'=>&$decoder->body
							  );
			}
		}
		// ̑
		else {
			$this->attachments[] = array( 'mime_type'=>$decoder->ctype_primary.'/'.$decoder->ctype_secondary,
						  'file_name'=>$decoder->ctype_parameters['name'],
						  'binary'=>&$decoder->body
						  );
		}
		}
	}
	}
	
	/**
	 * [Ytt@Cׂ
	 * 
	 * @access private
	 * @return bool 	 YttȂ true  false Ԃ
	 */
	function isMultiPart() {
		return (count($this->attachments) > 0) ? true : false;
	}
	
	/**
	 * Ytt@C̐𐔂
	 * 
	 * @access private
	 * @return int
	 */
	function getNumOfAttach() {
		return count($this->attachments);
	}
	
	/**
	 * Towb_AhX݂̂擾
	 * 
	 * @access public
	 * @return string toAhX ΃J}؂ŕԂ
	 * @see getHeaderAddresses(), extractionEmails()
	 */
	function getToAddr() {
		return $this->getHeaderAddresses( 'to' );
	}
	
	/**
	 * Fromwb_AhX݂̂擾
	 * 
	 * @access public
	 * @return string FromAhX ΃J}؂ŕԂ
	 * @see getHeaderAddresses(), extractionEmails()
	 */
	function getFromAddr () {
		return $this->getHeaderAddresses( 'from' );
	}
	
	function getReplyAddr() {
		return $this->getRawHeader( 'Reply-to' );
	}
	
	/**
	 * Ytt@Cۑ
	 * 
	 * @todo   Mail_mimeDecode ̓}`p[gbase64decode̖ʓ|݂͂ȂH
	 * @access public
	 * @param  int
	 * @param  string $str_path
	 * @return bool  Ȃ true sȂ false Ԃ
	 */
	function saveAttachFile ( $index, $str_path ) {
	
		if ( !file_exists($str_path) ) {
			if ( !is_writable(dirname($str_path)) ) {
			return false;
			}
		} else {
			if ( !is_writable($str_path) ) {
				return false;
			}
		}
		
		if ( !isset($this->attachments[$index]) ) {
			return false;
		}
		
		if ( $fp=fopen($str_path, "wb") ) {
			fwrite($fp, $this->attachments[$index]['binary'] );
			fclose($fp);
			return true;
		}
		
		return false;
	}
}
